#ifndef _TF5800_
#define _TF5800_

extern int __tap_Header__;
extern int __startPoint;
extern int _initData;
//extern int TAP_Main;
extern int _tap_gotStart;
extern int _tap_gotEnd;
extern int _tap_textEnd;
extern int _tap_fixupStart;
extern int _tap_fixupEnd;
//extern int TAP_EventHandler;
extern int _gp;
extern int _end;

//typedef struct
//{
//    byte signature[32];					//TFAMIPS
//    dword id;
//    byte padding1[28];
//    const char name[MAX_PROGRAM_NAME];
//    const char authorName[MAX_AUTHOR_NAME];
//    const char description[MAX_DESCRIPTION];
//    const char etcStr[MAX_ETCINFO_STR];
//} type_TAPHeader;
//
//typedef struct
//{
//    // From libtap.a
//    dword _initData;
//    /*TAP_MainFn*/void * TAP_Main;
//    dword _tap_gotStart;
//    dword _tap_gotEnd;
//    dword _tap_textEnd;
//    dword _tap_fixupStart;
//    dword _tap_fixupEnd;
//    /*TAP_EventHandlerFn*/void * TAP_EventHandler;
//    dword _gp;
//    dword _end;
//
//    void *pTAP_SystemProc;
//    void *_appl_version;
//    void *var_20;
//    void *pTAP_GetState;
//    void *pTAP_ExitNormal;
//    void *pTAP_EnterNormal;
//    void *var_10;
//    void *var_C;
//    void *pTAP_Exit;
//    void *pTAP_KbHit;
//    void *pTAP_GetCh;
//    void *pTAP_PutCh;
//    void *pTAP_Print;
//    void *pTAP_GetNewFunction;
//    //etc
//} type_TAPEntryPoints;
//
//typedef struct
//{
//    dword firmwaregp;
//    dword tapgp;
//    dword unknown1;
//    type_TAPHeader *header;
//    type_TAPEntryPoints *entryPoints;
//    dword loadAddress;
//    dword unknown2;
//    dword zero;
//} type_TAPProcess;

//----------------------------------------------------------------------------
//
//menu stuff
//
typedef struct {
    int value;
    char string[0x20];
} type_state;

typedef struct {
    int  id;
    char str[0x20];
}type_item;

typedef struct {
    int  id;
    int  visible;
    TYPE_Window win;
    int  rgn;
    char *fixme_titlep;
    type_item item[0x20];
}type_menu;

extern dword message_showing;
extern dword message_rgn;

extern void ShowMenu(type_menu *menu);
extern void DeleteMenu(type_menu *menu);
//extern void ShowMessage(char* lpMessage, char* lpMessage1, dword dwDelay);
extern dword ShowMessage(char *lpMessage, char *lpMessage1, dword dwDelay, int wait);
extern void ShowSvcnumWin(int svc);

//----------------------------------------------------------------------------
extern type_state state_str[];
extern type_state substate_str[];
extern type_state service_type_str[];
extern type_state attribute_str[];

extern char *getstate_str(int index);
extern char *getsubstate_str(int index);

//----------------------------------------------------------------------------
//
//log stuff
//
enum {
    DELAY_SHORT  = 100,     //1s
    DELAY_MEDIUM = 500,     //5s
    DELAY_LONG   = 1000,    //10s
};
enum {
    LOG_SERIAL = 1,
    LOG_SCREEN_CONT  = 2,
    LOG_SCREEN_WAIT  = 4,
    LOG_FILE = 8,
};

extern char strLog[0x100];
extern TYPE_File *OpLog;

extern int log_message(int log, char *str, int delay);

//----------------------------------------------------------------------------
//
//misc stuff
//
extern void dump(dword addr, int length);
extern int dump_channels(void);
extern int get_channel_number(int service_id);
extern void status();

//----------------------------------------------------------------------------
extern char *mjdToString(dword time);
char *padString(char *in, int len);
//----------------------------------------------------------------------------
//typedef struct
//{
//    dword   tableId                     :8;
//    dword   section_syntax_indicator    :1;
//    dword   reserved                    :3;
//    dword   sectionLength               :12;
//    dword   service_id_h                :8;
//    dword   service_id_l                :8;
//    dword   reserved2                   :2;
//    dword   version_number              :5;
//    dword   current_next_indicator      :1;
//    dword   section_number              :8;
//    dword   lastSectionNumber           :8;
//    dword   transport_stream_id         :16;
//    dword   original_network_id         :16;
//    dword   segment_last_section_number :8;
//    dword   last_table_id               :8;
//    dword   event_id                    :16;
//    dword   start_time_mjd              :16;
//    dword   start_time_hour             :8;
//    dword   start_time_min              :8;
//    dword   start_time_sec              :8;
//    dword   duration                    :24;
//    word    runningStatus               :3;
//    word    free_ca_mode                :1;
//    word    descriptor_loop_length      :12;
//} TYPE_Eit;
//
//----------------------------------------------------------------------------
extern int IsChannelInfoShown(void);
extern int IsAnythingShown(void);
extern int OsdActive(int iStartingRow, int iEndingRow);
//----------------------------------------------------------------------------
extern void ShowMainChannelInfo();
extern void ShowSubChannelInfo();
extern void ShowChannelInfo(int channel_type, int channel_number);
extern void ShowMainChannelEPG();
extern void ShowSubChannelEPG();
extern void ShowChannelEPG(int channel_type, int channel_number);
extern void dumpEvent(TYPE_exTapEvent *evt_info);
extern void dumpFileDetails(TYPE_File *file);
extern void dumpRecording(int slot);
extern void dumpPlaying();
extern void dumpTimer(int timerNo);
//----------------------------------------------------------------------------
extern void benchmark(int state, char *str);
//----------------------------------------------------------------------------
extern void to_bytes(ulong64 value64);
//----------------------------------------------------------------------------

#endif //_TF5800_
